#ifndef SIGR_GRAPH_H
#define SIGR_GRAPH_H

#include <sys/times.h>

#define graph_alloc_step 256

#if 0
#define likely(x) __builtin_expect(!!(x), 1)
#define unlikely(x) __builtin_expect(!!(x), 0)
#else
#define likely(x) (x)
#define unlikely(x) (x)
#endif

typedef int vertex_t;
typedef int edge_t;
typedef int iter_t;

#include "graph-matrix.h" /* struct graph, iter_t */

struct graph *graph_init(int prealloc);
struct graph *graph_random(int vertices, int edges, int v_domain, int e_domain);

vertex_t graph_get_vertex(struct graph *g, int v);
void graph_set_vertex(struct graph *g, int v, vertex_t value);
int graph_add_vertex(struct graph *g, vertex_t value);

edge_t graph_get_edge(struct graph *g, int v1, int v2);
void graph_set_edge(struct graph *g, int v1, int v2, edge_t e);

iter_t graph_first_edge(struct graph *g, int v1);
int graph_iter_to_vertex(struct graph *g, int v1, iter_t i);
int graph_next_edge(struct graph *g, int v1, iter_t i);

void graph_print(struct graph *g);

extern clock_t start_time;
void timestats(void);

#endif
