#include <stdio.h>
#include <stdlib.h>
#include <sys/times.h>
#include "graph.h"

#if 0
#include "graph-matrix.c"
#include "graph.c"
#endif

enum v_color {
	V_NONE,
	V_RED,
	V_GREEN,
	V_BLUE,
};

/* DFS */
int count_color(struct graph *g, int v, enum v_color c)
{
	int count = 0;
	graph_set_vertex(g, v, V_NONE);
	for (iter_t i = graph_first_edge(g, v); i >= 0; i = graph_next_edge(g, v, i)) {
		int v2 = graph_iter_to_vertex(g, v, i);
		enum v_color nei_color = graph_get_vertex(g, v2);
		if (nei_color != V_NONE)
			count += (nei_color == c) + count_color(g, v2, c);
	}
	return count;
}

int main(int argc, char *argv[]) {
	if (argc != 4) {
		fprintf(stderr, "Usage: %s VERTICES EDGES SEED\n", argv[0]);
		return EXIT_FAILURE;
	}
	srand(atoi(argv[3]));
	start_time = times(NULL);

	int vertices = atoi(argv[1]);
	int edges = atoi(argv[2]);
	struct graph *g = graph_random(vertices, edges, V_BLUE, 0);
	timestats();

	printf("%d\n", count_color(g, 0, V_GREEN));
	timestats();

	return EXIT_SUCCESS;
}
